---
title: OpenType font features guide
slug: Web/CSS/CSS_Fonts/OpenType_fonts_guide
tags:
  - CSS
  - Fonts
  - Guide
  - Text
  - font-feature-settings
  - opentype
---
<div>{{CSSRef}}</div>

<p class="summary">Font features or variants refer to different glyphs or character styles contained within an OpenType font. These include things like ligatures (special glyphs that combine characters like 'fi' or 'ffl'), kerning (adjustments to the spacing between specific letterform pairings), fractions, numeral styles, and a number of others. These are all referred to as OpenType Features, and are made available to use on the web via specific properties and a low-level control property — {{cssxref("font-feature-settings")}}. This article provides you with all you need to know about using OpenType font features in CSS.</p>

<p>Some fonts will have one or more of these features enabled by default (kerning and default ligatures are common examples), while others are left to the designer or developer to choose to enable in specific scenarios.</p>

<p>In addition to broad feature sets like ligatures or lining figures (numerals that line up evenly as opposed to 'oldstyle', which look more like lower-case letters), there are also very specific ones such as stylistic sets (which might include several specific variants of glyphs meant to be used together), alternates (which might be one or more variants of the letter 'a'), or even language-specific alterations for East Asian languages. In the latter case, these alterations are actually necessary to properly express the language, so they go beyond the more stylistic preference of most other OpenType features.</p>

<div class="warning">
<p><strong>Caution</strong>: There are many CSS attributes defined to leverage font features, but unfortunately many are not fully implemented. They are all defined and shown here, but many will only work using the lower-level {{cssxref("font-feature-settings")}} property. It's possible to write CSS to work both ways but this can become cumbersome. The issue with using <code>font-feature-settings</code> for everything is that every time you want to change one of the individual features, you have to redefine the entire string (similar to manipulating variable fonts with {{cssxref("font-variation-settings")}}).</p>
</div>

<h2 id="Discovering_availability_of_features_in_fonts">Discovering availability of features in fonts</h2>

<p>This is sometimes the trickiest thing to work out if you don't have any documentation that came with the fonts (many type designers and foundries will provide sample pages and CSS just for this very reason). But there are some sites that make it easier to figure out. You can visit <a href="https://wakamaifondue.com">wakamaifondue.com</a>, drop your font file on the circle where instructed and in a few moments you'll have a full report on all the capabilities and features of your font. <a href="https://axis-praxis.org">Axis-praxis.org</a> also offers a similar capability, with the ability to click on the features to turn them on or off in a given text block.</p>

<h2 id="Why_you_would_use_them">Why you would use them?</h2>

<p>Given that these features take a bit of work to discover and use, it may seem a fair question to ask why one would bother to use them. The answer lies in the specific features that will make a site more useful, readable, and polished:</p>

<ul>
 <li><strong>Ligatures</strong> like 'ff' or 'fi' make letter spacing and reading more even and smooth.</li>
 <li><strong>Fractions</strong> can make home improvement and recipe sites much easier to read and understand.</li>
 <li><strong>Numerals</strong> within paragraphs of text set as 'oldstyle' sit more comfortably between lower-case letters, and likewise setting them as 'tabular numbers' will make them line up better when setting a list of costs in a table say. 'lining' figures on the other hand sit more uniformly on their own or in front of capitalized words.</li>
</ul>

<p>While none of these features individually will render a site useless due to their absence, each of them in turn can make a site easier to use and more memorable for its attention to detail.</p>

<blockquote>
<p>OpenType features are like secret compartments in fonts. Unlock them and you'll find ways to make fonts look and behave differently in subtle and dramatic ways. Not all OpenType features are appropriate to use all of the time, but some features are critical for great typography. <cite><em>-- Tim Brown, Head of Typography at Adobe</em>.</cite></p>
</blockquote>

<h3 id="Sometimes_its_substance_not_just_style">Sometimes it's substance, not just style</h3>

<p>There are some cases — like with {{cssxref("font-variant-east-asian")}} — that OpenType features are directly tied to using different forms of certain glyphs, which can impact meaning and readability. In cases such as these it's more than just a nicety, but rather an integral part of the content itself.</p>

<h2 id="The_font_features">The font features</h2>

<p>There are a number of different features to consider. They are grouped and explained here according to the main attributes and options covered in the W3C specifications.</p>

<div class="note">
<p><strong>Note</strong>: The examples below show the properties and some example combinations, along with the lower-level syntax equivalents. They may not match exactly due to browser implementation inconsistencies, but in many cases the first example will match the second. The typefaces shown are Playfair Display, Source Serif Pro, IBM Plex Serif, Dancing Script, and Kokoro (all available and free to use, most are on Google Fonts and other services).</p>
</div>

<h3 id="Kerning_cssxreffont-kerning">Kerning ({{cssxref("font-kerning")}})</h3>

<p>This refers to the spacing between specific glyph pairings. This is generally on by default (as recommended by the OpenType specification). It should be noted that if {{cssxref("letter-spacing")}} is also set on your text, that is applied after kerning.</p>

<div>{{EmbedGHLiveSample("css-examples/font-features/font-kerning.html", '100%', 520)}}</div>

<h3 id="Alternates_cssxreffont-variant-alternates">Alternates ({{cssxref("font-variant-alternates")}})</h3>

<p>Fonts can supply a number of different alternatives for various glyphs, such as different styles of lower case 'a' or more or less elaborate swashes in a script typeface. This property can activate an entire set of alternates or just a specific one, depending on the values supplied.The example below is showing several different aspects of working with alternate characters. Fonts with alternate glyphs can make them available across the board or individually in separate stylistic sets, or even individual characters. In this example you can see two different typefaces, and the introduction of the {{cssxref("@font-feature-values")}} at-rule. This is used to define shortcuts or named options that can be defined per font family. This way you can create a named option that applies to only a single font, or one that is shared and can be applied more generally</p>

<div>{{EmbedGHLiveSample("css-examples/font-features/font-variant-alternates.html", '100%', 800)}}</div>

<p>In this case, <code>@stylistic(alternates)</code> will show all the alternate characters for either font). Applying this to just the word 'My' alters the way the 'M' renders, and applying <code>@styleset(alt-a)</code> only changes the lower case 'a'.</p>

<p>Try changing the line</p>

<pre class="brush: css notranslate">font-variant-alternates: styleset(alt-a);</pre>

<p>to</p>

<pre class="brush: css notranslate">font-variant-alternates: styleset(alt-g);
</pre>

<p>and notice that the lower case 'a' reverts to its regular form and the lower case 'g' changes instead.</p>

<h4 id="More_about_alternates">More about alternates</h4>

<ul>
 <li><a href="https://www.w3.org/TR/css-fonts-4/#propdef-font-variant-alternates">https://www.w3.org/TR/css-fonts-4/#propdef-font-variant-alternates</a></li>
 <li><a href="/en-US/docs/Web/CSS/font-variant-alternates">https://developer.mozilla.org/en-US/docs/Web/CSS/font-variant-alternates</a></li>
</ul>

<h3 id="Ligatures_cssxreffont-variant-ligatures">Ligatures ({{cssxref("font-variant-ligatures")}})</h3>

<p>Ligatures are glyphs that replace two or more separate glyphs in order to represent them more smoothly (from a spacing or aesthetic perspective). Some of the most common are letters like 'fi', 'fl', or 'ffl' — but there are many other possibilities. There are the most frequent ones (referred to as common ligatures), and there are also more specialized categories like 'discretionary ligatures', 'historical ligatures', and 'contextual alternates'. While these last ones are not technically ligatures, they are generally similar in that they replace specific combinations of letters when they appear together.</p>

<p>While more common in script typefaces, in the below example they are used to create arrows:</p>

<div>{{EmbedGHLiveSample("css-examples/font-features/font-variant-ligatures.html", '100%', 540)}}</div>

<h3 id="Position_cssxreffont-variant-position">Position ({{cssxref("font-variant-position")}})</h3>

<p>Position variants are used to enable typographic superscript and subscript glyphs. These are designed to work with the surrounding text without altering the baseline or line spacing. This is one of the key benefits over using the {{htmlelement("sub")}} or {{cssxref("sup")}} elements.</p>

<div>{{EmbedGHLiveSample("css-examples/font-features/font-variant-position.html", '100%', 550)}}</div>

<h3 id="Capitals_cssxreffont-variant-caps">Capitals ({{cssxref("font-variant-caps")}})</h3>

<p>One of the more common use cases for OpenType features is proper small caps. These are capital letters sized to fit better amongst lower case letters and are generally used for acronyms and abbreviations.</p>

<div>{{EmbedGHLiveSample("css-examples/font-features/font-variant-caps.html", '100%', 620)}}</div>

<h3 id="Numerals_cssxreffont-variant-numeric">Numerals ({{cssxref("font-variant-numeric")}})</h3>

<p>There are several different styles of numerals commonly included in fonts:</p>

<ul>
 <li>'Lining' figures are all the same height and on the same baseline.</li>
 <li>'Oldstyle' figures are mixed height and designed to have the appearance of ascenders and descenders like other lower case letters. These are designed to be used inline with copy so the numerals visually blend with the surrounding glyphs in a similar fashion to small caps.</li>
</ul>

<p>There is also the notion of spacing. Proportional spacing is the normal setting, whereas tabular spacing lines up numerals evenly regardless of character width, making it more appropriate for lining up tables of numbers in financial tables.</p>

<p>There are two types of fractions supported through this property:</p>

<ul>
 <li>Diagonal slashed fractions.</li>
 <li>Vertically stacked fractions.</li>
</ul>

<p>Ordinals are also supported (such as '1st' or '3rd'), as is a slashed zero if present in the font.</p>

<h4 id="Lining_and_Oldstyle_figures">Lining and Oldstyle figures</h4>

<div>{{EmbedGHLiveSample("css-examples/font-features/font-variant-numeric.html", '100%', 560)}}</div>

<h4 id="Fractions_ordinals_and_slashed_zero">Fractions, ordinals, and slashed zero</h4>

<div>{{EmbedGHLiveSample("css-examples/font-features/font-variant-numeric-frac.html", '100%', 600)}}</div>

<h3 id="East_Asian_cssxreffont-variant-east-asian">East Asian ({{cssxref("font-variant-east-asian")}})</h3>

<p>This allows access to various alternate forms of glyphs within a font. The example below shows a string of glyphs with only the OpenType set 'jis78' enabled. Uncheck the box below and you'll see more characters displayed.</p>

<div>{{EmbedGHLiveSample("css-examples/font-features/font-variant-east-asian.html", '100%', 750)}}</div>

<div class="note">
<p><strong>Note</strong>: these glyphs were copied out of a font sample and are not intended as prose.</p>
</div>

<h3 id="Font_variant_shorthand_Cssxreffont-variant">Font variant shorthand ({{Cssxref("font-variant")}})</h3>

<p>This is the shorthand syntax for defining all of the above. Setting a value of <code>normal</code> resets all properties to their initial value. Setting a value of <code>none</code> sets <code>font-variant-ligatures</code> to none and all other properties to their initial value. (Meaning that if kerning is on by default, it will still be on even with a value of <code>none</code> being supplied here.)</p>

<div>{{EmbedGHLiveSample("css-examples/font-features/font-variant.html", '100%', 600)}}</div>

<h2 id="Font_feature_settings">Font feature settings</h2>

<p>{{cssxref("font-feature-settings")}} is the 'low level syntax' that allows explicit access to every named available OpenType feature. This gives a lot of control, but has some disadvantages in how it impacts inheritance and — as mentioned above — if you wish to change one setting, you have to redeclare the entire string (unless you're using <a href="/en-US/docs/Web/CSS/Using_CSS_variables">CSS custom properties</a> to set the values). Because of this, it's best to use the standard properties shown above wherever possible.</p>

<p>There a huge number of possible features. You can see examples of a number of them above, and there are several resources available for finding more of them.</p>

<p>The general syntax looks like this:</p>

<pre class="brush: css notranslate">.small-caps {
  font-feature-settings: "smcp", "c2sc";
}
</pre>

<p>According to the specification you can either supply just the 4-character feature code or supply a 1 following the code (for enabling that feature) or a 0 (zero) to disable it. This is helpful if you have a feature like ligatures enabled by default but you would like to turn them off, like so:</p>

<pre class="brush: css notranslate">.no-ligatures {
  font-feature-settings: "liga" 0, "dlig" 0;
}</pre>

<h4 class="brush: css" id="More_on_font-feature-settings_codes">More on font-feature-settings codes</h4>

<ul>
 <li class="brush: css"><a href="https://sparanoid.com/lab/opentype-features/">'The Complete CSS Demo for OpenType Features'</a> (can't vouch for the truth of the name, but it's pretty big)</li>
 <li><a href="https://en.wikipedia.org/wiki/List_of_typographic_features">A list of OpenType features on Wikipedia</a></li>
</ul>

<h2 id="Using_CSS_feature_detection_for_implementation">Using CSS feature detection for implementation</h2>

<p>Since not all properties are evenly implemented, it's good practice to set up your CSS using feature detection to utilize the correct properties, with {{cssxref("font-feature-settings")}} as the fallback.</p>

<p>For example, small caps can be set several ways, but if you want to ensure that no matter what the underlying capitalization is that you end up with everything in small caps, it requires 2 settings with <code>font-feature-settings</code> versus a single property value using {{cssxref("font-variant-caps")}}.</p>

<pre class="brush: css notranslate">.small-caps {
   font-feature-settings: "smcp", "c2sc";
}

@supports (font-variant-caps: all-small-caps) {
   .small-caps {
       font-feature-settings: normal;
       font-variant-caps: all-small-caps;
   }
}
</pre>

<h2 id="See_also">See also</h2>

<h3 id="Demos_of_CSS_OpenType_features_in_CSS">Demos of CSS OpenType features in CSS</h3>

<ul>
 <li><a href="https://sparanoid.com/lab/opentype-features/">The Complete CSS Demo for OpenType Features</a></li>
</ul>

<h3 id="Web_font_analysis_tools">Web font analysis tools</h3>

<ul>
 <li><a href="https://wakamaifondue.com">Wakamai Fondue</a></li>
 <li><a href="https://axis-praxis.org">Axis Praxis</a></li>
</ul>

<h3 id="W3C_Specifications">W3C Specifications:</h3>

<ul>
 <li><a href="https://drafts.csswg.org/css-fonts-3/#font-rend-props">Font Feature Properties in CSS Fonts Module Level 3</a></li>
 <li><a href="https://www.w3.org/TR/css-fonts-4/#propdef-font-variant-alternates">font-variant-alternatives in CSS Fonts Module Level 4</a></li>
</ul>

<h3 id="Other_resources">Other resources</h3>

<ul>
 <li><a href="https://helpx.adobe.com/fonts/using/use-open-type-features.html">Using OpenType features</a> by Tim Brown, Head of Typography, Adobe</li>
 <li><a href="https://helpx.adobe.com/fonts/using/open-type-syntax.html">Adobe's Syntax for OpenType features in CSS</a></li>
</ul>
